diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 4629a5fb3..14058f6be 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -100,13 +100,13 @@ public abstract class BlockLogicFenceThin
 
         TilePos queryPos = new TilePos();
         int oy = 1;
-        while (source.getBlockId(tilePos.add(0, oy, 0, queryPos)) == this.block.id()) {
+        while (source.getBlockType(tilePos.add(0, oy, 0, queryPos)) == this.block) {
             oy++;
         }
         oy--;
 
         boolean drawColumnFromOther = false;
-        while (source.getBlockId(tilePos.add(0, oy, 0, queryPos)) == this.block.id()) {
+        while (source.getBlockType(tilePos.add(0, oy, 0, queryPos)) == this.block) {
             if (this.shouldDrawColumn_do(source, tilePos.add(0, oy, 0, queryPos))) {
                 drawColumnFromOther = true;
                 break;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
index 83afe05c4..a4c258f97 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
@@ -18,7 +18,7 @@ public class BlockLogicFenceWallPaper
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
         return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 949369358..9d8bc3ddb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -19,6 +19,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
+import java.util.Objects;
 import java.util.Random;
 
 public class BlockLogicFire
@@ -121,14 +122,14 @@ public class BlockLogicFire
     }
 
     public void setBurnResult(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
+        world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
     }
 
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         TilePos queryPos = new TilePos();
 
-        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down(queryPos));
+        final @Nullable Block<?> blockUnder = world.getBlockType(tilePos.down(queryPos));
         final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN);
 
         // Extinguish fire
@@ -150,7 +151,7 @@ public class BlockLogicFire
         if (meta < 15) {
             world.setBlockData(tilePos, meta + rand.nextInt(3) / 2);
         }
-        world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
 
 
         if (!infiniBurn && !this.canNeighborCatchFire(world, tilePos)) {
@@ -200,9 +201,9 @@ public class BlockLogicFire
                         continue;
                     }
 
-                    if (world.getGameRuleValue(GameRules.DO_FIRE_SPREAD) && this.getBurnResultId(world, localPos) == 0 /* Fix for fire destroying moss blocks */) {
+                    if (world.getGameRuleValue(GameRules.DO_FIRE_SPREAD) && this.getBurnResult(world, localPos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
                         //Spread Fire with higher meta
-                        world.setBlockIdDataNotify(localPos, this.block.id(), Math.min(meta + rand.nextInt(5) / 4, 15));
+                        world.setBlockTypeDataNotify(localPos, this.block, Math.min(meta + rand.nextInt(5) / 4, 15));
                     }
                 }
             }
@@ -211,13 +212,13 @@ public class BlockLogicFire
 
     private void checkBurn(final @NotNull World world, final @NotNull TilePos tilePos, final int chance, final @NotNull Random random, final int meta) {
         if (!world.getGameRuleValue(GameRules.DO_FIRE_SPREAD)) return;
-        if (random.nextInt(chance) < burnChance[world.getBlockId(tilePos)]) {
-            final boolean isTNT = world.getBlockId(tilePos) == Blocks.TNT.id();
+        if (random.nextInt(chance) < burnChance[world.getBlockType(tilePos).id()]) {
+            final boolean isTNT = world.getBlockType(tilePos) == Blocks.TNT;
 
             if (random.nextInt(meta + 10) < 5 && !world.isBlockBeingRainedOn(tilePos)) {
-                if (this.getBurnResultId(world, tilePos) == 0 /* Fix for fire destroying moss blocks */) {
+                if (this.getBurnResult(world, tilePos) == Blocks.AIR /* Fix for fire destroying moss blocks */) {
                     //Spread Fire with higher meta
-                    world.setBlockIdDataNotify(tilePos, this.block.id(), Math.min(meta + random.nextInt(5) / 4, 15));
+                    world.setBlockTypeDataNotify(tilePos, this.block, Math.min(meta + random.nextInt(5) / 4, 15));
                 }
             } else {
                 this.setBurnResult(world, tilePos);
@@ -256,7 +257,7 @@ public class BlockLogicFire
     }
 
     public static boolean canBurn(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
-        return flameChance[source.getBlockId(tilePos)] > 0;
+        return flameChance[source.getBlockType(tilePos).id()] > 0;
     }
 
     public static boolean canBurn(final int blockId) {
@@ -264,7 +265,7 @@ public class BlockLogicFire
     }
 
     public static int getFlammability(final @NotNull World world, final @NotNull TilePosc tilePos, final int currentFlameChance) {
-        final int blockFlameChance = flameChance[world.getBlockId(tilePos)];
+        final int blockFlameChance = flameChance[world.getBlockType(tilePos).id()];
         return Math.max(blockFlameChance, currentFlameChance);
     }
 
@@ -278,32 +279,29 @@ public class BlockLogicFire
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!world.isBlockNormalCube(tilePos.down(new TilePos())) && !this.canNeighborCatchFire(world, tilePos)) {
 
-            world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
+            world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
         }
     }
 
-    protected int getBurnResultId(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        final int id = world.getBlockId(tilePos);
-        final @Nullable Block<?> stoneBlock = BlockLogicMoss.getStoneBlock(id);
-        if (stoneBlock != null) {
-            return stoneBlock.id();
-        }
-        return 0;
+    protected @NotNull Block<?> getBurnResult(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        final @Nullable Block<?> noMossBlock = BlockLogicMoss.getNoMossBlock(block);
+        return Objects.requireNonNullElse(noMossBlock, Blocks.AIR);
     }
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        if (world.getBlockId(tilePos.down(queryPos)) == Blocks.OBSIDIAN.id() && Blocks.PORTAL_NETHER.getLogic().tryToCreatePortal(world, tilePos, null)) {
+        if (world.getBlockType(tilePos.down(queryPos)) == Blocks.OBSIDIAN && Blocks.PORTAL_NETHER.getLogic().tryToCreatePortal(world, tilePos, null)) {
             return;
         }
         if (!world.isBlockNormalCube(tilePos.down(queryPos)) && !this.canNeighborCatchFire(world, tilePos)) {
-            world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
+            world.setBlockTypeNotify(tilePos, this.getBurnResult(world, tilePos));
         } else {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+            world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
index 8e98677c2..3b48a1e51 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -19,7 +19,7 @@ public class BlockLogicFireCold
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down(queryPos));
+        final @Nullable Block<?> blockUnder = world.getBlockType(tilePos.down(queryPos));
         final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN_COLD);
 
         // Extinguish fire
@@ -42,7 +42,7 @@ public class BlockLogicFireCold
         if (meta < 15) {
             world.setBlockData(tilePos, meta + rand.nextInt(3) / 2);
         }
-        world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
 
 
         if (!infiniBurn && !this.canNeighborCatchFire(world, tilePos)) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 75f5ac56c..378ebe4f0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -52,7 +52,7 @@ public class BlockLogicFlower
 
     @Override
     public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return super.canPlaceAt(world, tilePos) && this.mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
+        return super.canPlaceAt(world, tilePos) && this.mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
     }
 
     @Override
@@ -60,14 +60,13 @@ public class BlockLogicFlower
         return PartialSupport.INSTANCE;
     }
 
-    protected boolean mayPlaceOn(final int blockId) {
-        final @Nullable Block<?> block = Blocks.getBlock(blockId);
-        return block != null && block.hasTag(BlockTags.GROWS_FLOWERS);
+    protected boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block.hasTag(BlockTags.GROWS_FLOWERS);
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
-        super.onNeighborChanged(world, tilePos, id);
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
         this.checkAlive(world, tilePos);
     }
 
@@ -76,20 +75,20 @@ public class BlockLogicFlower
         this.checkAlive(world, tilePos);
 
         if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockData(tilePos))) && world.getSeasonManager().getCurrentSeason().killFlowers && this.killedByWeather && rand.nextInt(256) == 0) {
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     protected final void checkAlive(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (!this.canStay(world, tilePos)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     @Override
     public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return (world.getFullBlockLightValue(tilePos) >= 8 || world.canBlockSeeSky(tilePos)) && this.mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
+        return (world.getFullBlockLightValue(tilePos) >= 8 || world.canBlockSeeSky(tilePos)) && this.mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
     }
 
     public static boolean isPermanent(final int metadata) {
@@ -120,7 +119,7 @@ public class BlockLogicFlower
         final Random rand = world.rand;
         if (!world.isClientSide && this.canBeBonemealed && itemStack.consumeItem(player)) {
             {
-                if (Block.hasLogicClass(world.getBlock(tilePos), BlockLogicFlowerStackable.class)) {
+                if (Block.hasLogicClass(world.getBlockType(tilePos), BlockLogicFlowerStackable.class)) {
                     final int meta = world.getBlockData(tilePos);
                     if (BlockLogicFlowerStackable.getStackCount(meta) < BlockLogicFlowerStackable.MAX_STACK_COUNT) {
                         world.setBlockDataNotify(tilePos, BlockLogicFlowerStackable.setStackCount(meta, BlockLogicFlowerStackable.getStackCount(meta) + 1));
@@ -138,21 +137,21 @@ public class BlockLogicFlower
                     checkX += rand.nextInt(3) - 1;
                     checkY += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
                     checkZ += rand.nextInt(3) - 1;
-                    final int blockId = world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ));
-                    if (!this.mayPlaceOn(blockId)) {
+                    final @NotNull Block<?> block = world.getBlockType(queryPos.set(checkX, checkY - 1, checkZ));
+                    if (!this.mayPlaceOn(block)) {
                         continue outer;
                     }
                 }
 
-                final @Nullable Block<?> b = world.getBlock(queryPos.set(checkX, checkY, checkZ));
+                final @Nullable Block<?> b = world.getBlockType(queryPos.set(checkX, checkY, checkZ));
                 if (Block.hasLogicClass(b, BlockLogicFlowerStackable.class)) {
                     final int meta = world.getBlockData(queryPos.set(checkX, checkY, checkZ));
                     if (BlockLogicFlowerStackable.getStackCount(meta) < BlockLogicFlowerStackable.MAX_STACK_COUNT) {
                         world.setBlockDataNotify(queryPos.set(checkX, checkY, checkZ), BlockLogicFlowerStackable.setStackCount(meta, BlockLogicFlowerStackable.getStackCount(meta) + 1));
                     }
-                } else if (b == null) {
+                } else if (b.hasTag(BlockTags.PLACE_OVERWRITES)) {
                     if (rand.nextFloat() > 0.75) {
-                        world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                        world.setBlockTypeNotify(queryPos.set(checkX, checkY, checkZ), this.block);
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 757768063..374ef8cd2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -154,12 +154,12 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         checkForHarden(world, tilePos);
     }
 
     private void checkForHarden(final World world, final @NotNull TilePosc tilePos) {
-        if (world.getBlockId(tilePos) != this.block.id()) {
+        if (world.getBlockType(tilePos) != this.block) {
             return;
         }
         TilePos queryPos = new TilePos();
@@ -229,7 +229,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
 
     @Override
     public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        final Block<?> bBlock = world.getBlock(thatPos);
+        final Block<?> bBlock = world.getBlockType(thatPos);
 
         final int thisMeta = world.getBlockData(thisPos);
         final int otherMeta = world.getBlockData(thatPos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index f522a14d3..d8ac4e7b0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -25,7 +25,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
     }
 
     private void setFluidStill(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.setBlockIdData(tilePos, this.blockStill.id(), world.getBlockData(tilePos));
+        world.setBlockTypeData(tilePos, this.blockStill, world.getBlockData(tilePos));
         world.markBlocksDirty(tilePos, tilePos);
         world.markBlockNeedsUpdate(tilePos);
     }
@@ -67,11 +67,11 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             if (newFlowDecay != localFlowDecay) {
                 localFlowDecay = newFlowDecay;
                 if (localFlowDecay < 0) {
-                    world.setBlockIdNotify(tilePos, 0);
+                    world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 } else {
                     world.setBlockDataNotify(tilePos, localFlowDecay);
-                    world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
-                    world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+                    world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
+                    world.notifyBlocksOfNeighborChange(tilePos, this.block);
                 }
             } else {
                 setFluidStill(world, tilePos);
@@ -80,14 +80,14 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             setFluidStill(world, tilePos);
         }
         if (canSpreadTo(world, tilePos.down(queryPos))) {
-            Block<?> b = world.getBlock(tilePos.down(queryPos));
+            Block<?> b = world.getBlockType(tilePos.down(queryPos));
             if (b != null) {
                 b.dropWithCause(world, EnumDropCause.WORLD, tilePos.down(queryPos), world.getBlockData(tilePos.down(queryPos)), null, null);
             }
             if (localFlowDecay >= 8) {
-                world.setBlockIdDataNotify(tilePos.down(queryPos), this.block.id(), localFlowDecay);
+                world.setBlockTypeDataNotify(tilePos.down(queryPos), this.block, localFlowDecay);
             } else {
-                world.setBlockIdDataNotify(tilePos.down(queryPos), this.block.id(), localFlowDecay + 8);
+                world.setBlockTypeDataNotify(tilePos.down(queryPos), this.block, localFlowDecay + 8);
             }
         } else if (localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, tilePos.down(queryPos)))) {
             boolean[] spreadFlags = getSpread(world, tilePos);
@@ -115,11 +115,8 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
 
     private void flowIntoBlock(@NotNull World world, @NotNull TilePos tilePos, int meta) {
         if (canSpreadTo(world, tilePos)) {
-            int id = world.getBlockId(tilePos);
-            if (id > 0) {
-                this.fluid.onFlowIntoBlock(this, world, tilePos, meta);
-            }
-            world.setBlockIdDataNotify(tilePos, this.block.id(), meta);
+            this.fluid.onFlowIntoBlock(this, world, tilePos, meta);
+            world.setBlockTypeDataNotify(tilePos, this.block, meta);
         }
     }
 
@@ -197,8 +194,8 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
     }
 
     private boolean isFluidBlocking(@NotNull World world, @NotNull TilePos tilePos) {
-        Block<?> b = world.getBlock(tilePos);
-        return b != null && !(b.getLogic() instanceof BlockLogicFluid) && !b.hasTag(BlockTags.BROKEN_BY_FLUIDS);
+        Block<?> b = world.getBlockType(tilePos);
+        return !(b.getLogic() instanceof BlockLogicFluid) && !b.hasTag(BlockTags.BROKEN_BY_FLUIDS) && !b.hasTag(BlockTags.PLACE_OVERWRITES);
     }
 
     protected int getHighest(@NotNull World world, @NotNull TilePos tilePos, int currentFlowDecay) {
@@ -230,8 +227,8 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
-        if (world.getBlockId(tilePos) == this.block.id()) {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
+        if (world.getBlockType(tilePos) == this.block) {
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index 558e50a88..cceaa8ec0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -18,10 +18,9 @@ public class BlockLogicFluidStill extends BlockLogicFluid {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        super.onNeighborChanged(world, tilePos, id);
-        if (id == Side.TOP.getId()) return;
-        if (world.getBlockId(tilePos) == this.block.id()) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
+        if (world.getBlockType(tilePos) == this.block) {
             setFlowing(world, tilePos);
         }
     }
@@ -29,9 +28,9 @@ public class BlockLogicFluidStill extends BlockLogicFluid {
     private void setFlowing(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         world.noNeighborUpdate = true;
-        world.setBlockIdData(tilePos, this.blockFlowing.id(), meta);
+        world.setBlockTypeData(tilePos, this.blockFlowing, meta);
         world.markBlocksDirty(tilePos, tilePos);
-        world.scheduleBlockUpdate(tilePos, this.blockFlowing.id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.blockFlowing, tickDelay());
         world.noNeighborUpdate = false;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
index 3de77f003..4fd8d1502 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
@@ -85,15 +85,15 @@ public class BlockLogicFurnace extends BlockLogicRotatable {
             if (Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
             }
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             LOGGER.warn(msg);
             return;
         }
         keepFurnaceInventory = true;
         if (lit) {
-            world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_ACTIVE.id());
+            world.setBlockTypeNotify(tilePos, Blocks.FURNACE_STONE_ACTIVE);
         } else {
-            world.setBlockIdNotify(tilePos, Blocks.FURNACE_STONE_IDLE.id());
+            world.setBlockTypeNotify(tilePos, Blocks.FURNACE_STONE_IDLE);
         }
         keepFurnaceInventory = false;
         world.setBlockDataNotify(tilePos, meta);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
index 692b05482..1bd2a9610 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
@@ -88,15 +88,15 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
 				throw new RuntimeException(msg);
 			}
-			world.setBlockIdNotify(tilePos, 0);
+			world.setBlockTypeNotify(tilePos, Blocks.AIR);
             LOGGER.warn(msg);
 			return;
 		}
 		keepFurnaceInventory = true;
 		if(lit) {
-			world.setBlockIdNotify(tilePos, Blocks.FURNACE_BLAST_ACTIVE.id());
+			world.setBlockTypeNotify(tilePos, Blocks.FURNACE_BLAST_ACTIVE);
 		} else {
-			world.setBlockIdNotify(tilePos, Blocks.FURNACE_BLAST_IDLE.id());
+			world.setBlockTypeNotify(tilePos, Blocks.FURNACE_BLAST_IDLE);
 		}
 		keepFurnaceInventory = false;
 		world.setBlockDataNotify(tilePos, meta);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
index 9abaa9006..53bc266a1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
@@ -30,45 +30,47 @@ public class BlockLogicGrass extends BlockLogic {
             return;
         }
         TilePos queryPos = new TilePos();
-        if (world.getBlockLightValue(tilePos.up(queryPos)) < 4 && Blocks.lightBlock[world.getBlockId(tilePos.up(queryPos))] > 2) {
-            world.setBlockIdNotify(tilePos, this.dirt.id());
+        if (world.getBlockLightValue(tilePos.up(queryPos)) < 4 && world.getBlockType(tilePos.up(queryPos)).lightBlock() > 2) {
+            world.setBlockTypeNotify(tilePos, this.dirt);
         } else if (world.getBlockLightValue(tilePos.up(queryPos)) >= 9) {
             for (int i = 0; i < 4; i++) {
                 int checkX = (tilePos.x() + rand.nextInt(3)) - 1;
                 int checkY = (tilePos.y() + rand.nextInt(5)) - 3;
                 int checkZ = (tilePos.x() + rand.nextInt(3)) - 1;
-                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) == this.dirt.id() &&
+                if (world.getBlockType(queryPos.set(checkX, checkY, checkZ)) == this.dirt &&
                     world.getBlockLightValue(queryPos.set(checkX, checkY + 1, checkZ)) >= 4 &&
-                    Blocks.lightBlock[world.getBlockId(queryPos.set(checkX, checkY + 1, checkZ))] <= 2) {
-                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                    world.getBlockType(queryPos.set(checkX, checkY + 1, checkZ)).lightBlock() <= 2) {
+                    world.setBlockTypeNotify(queryPos.set(checkX, checkY, checkZ), this.block);
                 }
             }
-            if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getBlockId(tilePos.up(queryPos)) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().growFlowers && rand.nextInt(256) == 0) {
-                int idToSpawn = 0;
+            if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getBlockType(tilePos.up(queryPos)) == Blocks.AIR && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().growFlowers && rand.nextInt(256) == 0) {
+                @Nullable Block<?> blockToSpawn = null;
                 int r = rand.nextInt(400);
 
                 if (r < 26) {
-                    idToSpawn = Blocks.FLOWER_RED.id();
+                    blockToSpawn = Blocks.FLOWER_RED;
                 } else if (r < 41) {
-                    idToSpawn = Blocks.FLOWER_YELLOW.id();
+                    blockToSpawn = Blocks.FLOWER_YELLOW;
                 } else if (r < 60) {
                     Biome biome = world.getBlockBiome(tilePos.up(queryPos));
                     if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST) {
-                        idToSpawn = Blocks.FLOWER_PINK.id();
+                        blockToSpawn = Blocks.FLOWER_PINK;
                     } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
-                        idToSpawn = Blocks.FLOWER_PURPLE.id();
+                        blockToSpawn = Blocks.FLOWER_PURPLE;
                     } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_CAATINGA) {
-                        idToSpawn = Blocks.FLOWER_LIGHT_BLUE.id();
+                        blockToSpawn = Blocks.FLOWER_LIGHT_BLUE;
                     }
                 } else {
                     if (rand.nextInt(8) == 0) {
-                        idToSpawn = Blocks.TALLGRASS_FERN.id();
+                        blockToSpawn = Blocks.TALLGRASS_FERN;
                     } else {
-                        idToSpawn = Blocks.TALLGRASS.id();
+                        blockToSpawn = Blocks.TALLGRASS;
                     }
                 }
 
-                world.setBlockIdNotify(tilePos.up(queryPos), idToSpawn);
+                if (blockToSpawn != null) {
+                    world.setBlockTypeNotify(tilePos.up(queryPos), blockToSpawn);
+                }
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
index cf6f6c31c..251085fcf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
@@ -36,16 +36,16 @@ public class BlockLogicIce extends BlockLogicTransparent {
         super.onHarvest(world, player, tilePos, data, tileEntity);
         Material material = world.getBlockMaterial(tilePos.down(new TilePos()));
         if(material.blocksMotion() || material.isLiquid()) {
-            world.setBlockIdNotify(tilePos, Blocks.FLUID_WATER_FLOWING.id());
+            world.setBlockTypeNotify(tilePos, Blocks.FLUID_WATER_FLOWING);
         }
     }
 
     @Override
 	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick)
     {
-        if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11 - Blocks.lightBlock[id()])
+        if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11 - this.block.lightBlock())
         {
-            world.setBlockIdNotify(tilePos, Blocks.FLUID_WATER_STILL.id());
+            world.setBlockTypeNotify(tilePos, Blocks.FLUID_WATER_STILL);
         }
     }
 
